<template>
  <BasicModal v-bind="$attrs" @register="registerModal" :title="title" @ok="handleSubmit" width="50%">
    <BasicForm @register="registerForm"> </BasicForm>
  </BasicModal>
</template>

<script lang="ts" setup>
  import { ref } from 'vue';
  import { FormSchema } from '/@/components/Table';
  import { BasicModal, useModalInner } from '/@/components/Modal';
  import { BasicForm, useForm } from '/@/components/Form/index';

  import { updateCx } from '@/api/common/api';
  import { useMessage } from '/@/hooks/web/useMessage';

  const { createMessage } = useMessage();
  const BackFormSchema: FormSchema[] = [
    // {
    //   label: '污染地块id',
    //   field: 'wrdkid',
    //   component: 'ApiSelect',
    //   show: false,
    // },
    // {
    //   label: 'pgtype',
    //   field: 'pgtype',
    //   component: 'ApiSelect',
    //   show: false,
    // },
    // {
    //   label: '阶段编码',
    //   field: 'scjdbm',
    //   component: 'ApiSelect',
    //   show: false,
    // },
    // {
    //   label: '填报阶段编码',
    //   field: 'tbjdbm',
    //   component: 'ApiSelect',
    //   show: false,
    // },
    {
      label: '专家意见id',
      field: 'zjyjid',
      component: 'ApiSelect',
      show: false,
    },
    {
      label: '修改后材料上传',
      field: 'xghdcl',
      component: 'JUpload',
      required: true,
      componentProps: {
        showUploadList: false,
        fileName: '退回文件',
        accept: '.pdf,.zip',
        beforeUpload: (file) => {
          let isshow = false;
          const isFile = file.name.split('.')[file.name.split('.').length - 1];
          console.log(file, 'file');
          if (isFile == 'pdf' || isFile == 'zip' || isFile == 'PDF') {
            isshow = true;
          } else {
            createMessage.error('只能上传.pdf/.zip格式的文件');
            isshow = false;
          }
          return isshow;
        },
      },
    },
  ];
  // Emits声明
  const emit = defineEmits(['register', 'success']);

  const isUpdate = ref(true);
  //表单配置
  const [registerForm, { resetFields, setFieldsValue, validate }] = useForm({
    labelWidth: 220,
    schemas: BackFormSchema,
    // autoAdvancedCol: 2,
    // baseColProps: { span: 12 },
    showActionButtonGroup: false,
  });
  //表单赋值
  const [registerModal, { setModalProps, closeModal }] = useModalInner(async (data) => {
    //重置表单
    await resetFields();
    setModalProps({ confirmLoading: false, showCancelBtn: data?.showFooter, showOkBtn: data?.showFooter });
    //表单赋值
    await setFieldsValue({
      ...data.record,
    });
  });
  //设置标题
  const title = ref('材料上传');
  //表单提交事件
  async function handleSubmit() {
    try {
      let values = await validate();
      setModalProps({ confirmLoading: true });
      //提交表单
      await updateCx(values);
      //关闭弹窗
      closeModal();
      //刷新列表
      emit('success', { isUpdate: isUpdate.value, values });
    } finally {
      setModalProps({ confirmLoading: false });
    }
  }
</script>

<style lang="less" scoped></style>
